#!/usr/bin/php -q
<?php
/*
ini_to_db.php
version:1.07
*/
//include("class.iniparser.php");
$DEBUG=1;
include("database.php");
ini_to_db();


function ini_to_db(){
		
	$strpath="/usr/conf/";
	//$strpath="";
	$db=new beroAri($strpath . "ari.db");
	
	$result=isdncfg_initoDB($db,$strpath);
	$result=isgwisdn_initoDB($db,$strpath);	
	$result=isgwsip_initoDB($db,$strpath);		
	$result=isgwdialplan_initoDB($db,$strpath);
	$result=isgwconf_initoDB($db,$strpath);
	
}
function make_parseable_inifile($sFile,$dFile){
	
	$handle = @fopen($sFile, "r"); // Open file form read.
	$whandle=fopen($dFile,"w");
	if ($handle) {
		$i=0;
		while (!feof($handle)) // Loop til end of file.
		{
			$buffer = fgets($handle, 4096); // Read a line.
			if(strpos($buffer,"config")!==false){
				$eqpos=strpos($buffer,"=");
				$value=trim(substr($buffer,$eqpos+1));
				$buffer="config=\"" . $value . "\"\n";
				//echo $buffer ."\n";
			}
			if(strpos($buffer,"tones")!==false){
				$buffer=str_replace("[","",$buffer);
				$buffer=str_replace("]","",$buffer);
				//echo $buffer . "\n";
				
			}
			if(strpos($buffer,"overlap_dialing")!==false){
				$buffer=str_replace("yes","1",$buffer);
				$buffer=str_replace("no","0",$buffer);
				//echo $buffer . "\n";
				
			}
			if(strpos($buffer,"sip_over_tcp")!==false){
				$buffer=str_replace("yes","1",$buffer);
				$buffer=str_replace("no","0",$buffer);
				//echo $buffer . "\n";
				
			}
			if(strpos($buffer,"time_from_isdn")!==false){
				$buffer=str_replace("yes","1",$buffer);
				$buffer=str_replace("no","0",$buffer);
				//echo $buffer . "\n";
				
			}
			if(strpos($buffer,"qsig")!==false){
				$buffer=str_replace("yes","1",$buffer);
				$buffer=str_replace("no","0",$buffer);
				//echo $buffer . "\n";
				
			}
			$wbuffer=fwrite($whandle,$buffer);
			$i++;
			//echo $i . ":"  .$buffer . "\n";			
		}
	fclose($handle); // Close the file.
	}
	return;
	
}
function isgwconf_initoDB($db,$strpath){
	global $DEBUG;
	
	
	if (!file_exists($strpath . "isgw.conf"))exit(-1);
	$result=parse_ini_file($strpath . "isgw.conf",true);
	
	foreach	($result as $section=>$values){
		
		if ($section=="general"){
			
			
			$statusport=$result[$section][statusport];
			$logserver=$result[$section][logserver];
			$logging_active=$result[$section][logging_active];
			$loglevel=$result[$section][loglevel];
			$telnetacl=$result[$section][telnet_acl];
			if($telnetacl=="")$telnetacl="127.0.0.1/32";
			
			$syslog_facility=$result[$section][syslog_facility];
			if($syslog_facility=="")$syslog_facility="16";
			$strsql="update key_val set value='" . $syslog_facility  . "' where key='syslog_facility'";
			if($DEBUG) echo "isgwconf->DB: Key_val:" .$strsql ." \n";
			$res=$db->insert_($strsql);
			if (!$res) exit(-1);
			
			
			$strsql ="Insert into general ('id','logserver','logging_active','msp_device_ip','loglevel','telnet_acl') Values";
			$strsql.="(1,";
			$strsql.="'" . $logserver . "',";
			$strsql.="'" . $logging_active . "',";
			$strsql.="'192.168.173.1',";
			$strsql.="". $loglevel . ",";
			$strsql.="'" . $telnetacl . "')";
						
			if($DEBUG) echo "isgwconf->DB: " .$strsql ." \n";
			$res=$db->delete("delete from general");
			$res=$db->insert_($strsql);
			
			if (!$res) exit(-1);
					
		}
	}
}
function isgwdialplan_initoDB($db,$strpath){
	global $DEBUG;
	if (!file_exists($strpath . "isgw.dialplan"))exit(-1);
	$handle = @fopen($strpath ."isgw.dialplan", "r"); // Open file form read.
	$res=$db->delete("delete from dialplan");
	if ($handle) {
		$i=0;
		while (!feof($handle)) // Loop til end of file.
		{
			$buffer = fgets($handle, 4096); // Read a line.
			if ($i>=1)
			{
				
				$result=split("\t",trim($buffer));
				$z=0;	
							
				if(count($result)>"1"){
					$isdnid="";
					if(substr($result[4],0,10)=="ISDNZUISDN"){
						$isdnid=substr($result[4],0,23);
					}					
					if(substr($result[5],0,10)=="ISDNZUISDN"){
						$isdnid=substr($result[5],0,23);
					}					
					
					$strsql="Insert into dialplan ('id','direction','fromId','toId','dest','newDest','src','newSrc','config','isdnid') ";
					$strsql.="values (" . $i . ",'" . $result[0] . "-" . $result[1] ."',";
					$strsql.="'" . $result[2] . "',";
					$strsql.="'" . $result[3] . "',";
					$strsql.="'" . $result[4] . "',";
					$strsql.="'" . $result[5] . "',";
					$strsql.="'" . $result[6] . "',";
					$strsql.="'" . $result[7] . "',";
					$strsql.="'" . $result[8] . "',";
					$strsql.="'" . $isdnid . "')";
					
					
					$strsql=str_replace("\\","\\\\",$strsql);
					
					
					
					if($DEBUG)echo "isgwdialplan: " .$strsql . "\n";
					$res=$db->insert_($strsql);
					//if (!$res) exit(-1);
				}
			}
			$i++;
			
		}
	}
}
function isgwsip_initoDB($db,$strpath){
	global $DEBUG;
	if (!file_exists($strpath . "isgw.sip"))exit(-1);
	$result=make_parseable_inifile($strpath ."isgw.sip",$strpath ."isgw.sip.tmp");
	
	$result=parse_ini_file($strpath ."isgw.sip.tmp",true);
	$res=$db->delete("delete from sip_general");
	$res=$db->delete("delete from sip");
	$i=0;
	foreach	($result as $section=>$values){
		if ($section=="general"){
			$sip_address=split(":",$result[$section][sip_address]);
			$bindport=$sip_address[2];
			$udpports=$result[$section][udpports];
			$externip=$result[$section][externip];
			$sip_over_tcp=$result[$section][sip_over_tcp];
			if($sip_over_tcp=="")$sip_over_tcp="no";
			$strsql="update key_val set value='" . $sip_over_tcp  . "' where key='sip_over_tcp'";
			if($DEBUG) echo "isgwsip->DB: " . $section . "Key_val:" .$strsql ." \n";
			$res=$db->insert_($strsql);
			if (!$res) exit(-1);
			
			$strsql ="Insert into sip_general ('id','udpports','bindport','externip') values (";
			$strsql.="1,";
			$strsql.="'" . $udpports . "',";
			$strsql.="'" . $bindport . "',";
			$strsql.="'" . $externip . "')";
			if($DEBUG) echo "isgwsip->DB: " . $section . ":" .$strsql ." \n";
			$res=$db->insert_($strsql);
			if ((strpos($res,"failed")!==false) || !$res)exit(-1);
			//if ($res!=str_replace("failed","",$res))exit(-1);
			//if (preg_match("/failed/",$res) || !$res)exit(-1);
		}else{
			$i++;
			$address=$result[$section][address];
			$type=$result[$section][type];
			$user=$result[$section][user];
			$secret=$result[$section][secret];
			$externip=$result[$section][externip];
			$config=$result[$section][config];
			$default=$result[$section]['default'];
			if ($default!=1 || $default!=0)$default=0;
			
			$strsql ="Insert into sip ('id','name','server_address',";
			$strsql.="'user','secret','type','config','def','stunserver',";
			$strsql.="'externip')";
			$strsql.=" values (";
			$strsql.=$i .",";
			$strsql.="'" . $section . "',";
			$strsql.="'" . $address . "',";
			$strsql.="'" . $user . "',";
			$strsql.="'" . $secret . "',";
			$strsql.="'" . $type . "',";
			$strsql.="'" . $config . "',";
			$strsql.= $default . ",";
			$strsql.="'',";
			$strsql.="'" . $externip  .  "')";
			if($DEBUG) echo "isgwsip->DB: " . $section . ":" .$strsql ." \n";
			$res=$db->insert_($strsql);
			if ((strpos($res,"failed")!==false) || !$res)exit(-1);
			
			
			
			
		}
		
	}
	$res=unlink($strpath ."isgw.sip.tmp");
}

function isgwisdn_initoDB($db,$strpath){
	global $DEBUG;
	
	if (!file_exists($strpath . "isgw.isdn"))exit(-1);
	
	$result=make_parseable_inifile($strpath ."isgw.isdn",$strpath ."isgw.isdn.tmp");
	$result=parse_ini_file($strpath ."isgw.isdn.tmp",true);
	
	foreach	($result as $section=>$values){
		if($section!="general"){
		$ports=$result[$section][ports];
		$chansel=$result[$section][chansel];
		$config= $result[$section][config];
		$tones= $result[$section][tones];
		$odt=$result[$section][overlap_dial_timeout];
		$odial=$result[$section][overlap_dialing];
		$qsig=$result[$section][qsig];
		if($qsig=="")$qsig="0";
		if ($qsig==1)
		{
			$qsig="1";
		}else{
			$qsig="0";
		}
		if($odial=="")$odial="0";
		if ($odial==1)
		{
			$odial="1";
		}else{
			$odial="0";
		}
		
		$odtwe=$result[$section][overlap_dial_timeout_empty_dad];
		
		
		
		$port=split(",",$ports);
		
		foreach ($port as $a){
			
			$strsql ="Update isdn set ";
			$strsql.="chansel ='". $chansel . "'";
			$strsql.=",gr='" . $section . "'";
			$strsql.=",config='" . $config . "'";
			$strsql.=",tones='[" . $tones . "]'";
			$strsql.=",odt=" . $odt;
			$strsql.=",odt_empty_dad=" . $odtwe;
			$strsql.=",qsig='" . $qsig . "'";
			$strsql.=",overlap_dialing='" . $odial . "'";
			$strsql.=" where port=" .$a;
			if($DEBUG) echo "ISGWISDN->DB: " . $section . ":" .$strsql ." \n";
			$res=$db->update($strsql);
			if (!$res) exit(-1);
		}
		}else{
			$time_from_isdn=$result[$section][time_from_isdn];
			if($time_from_isdn=="")$time_from_isdn="no";
			$dbroot=new beroAri($strpath . "root.db");
			$strsql="Update root set value='" . $time_from_isdn . "' where key='time_from_isdn'";
			if($DEBUG) echo "ROOTDB:TIME_FROM_ISDN->DB: " .$strsql . "\n";
			$res=$dbroot->update($strsql);
			if (!$res){
				 exit(-1);
			}else{
				if($time_from_isdn!="0"){
					$strsql="Update root set value='' where key='ntphost'";
					if($DEBUG) echo "ROOTDB:TIME_FROM_ISDN->DB: " .$strsql . "\n";
					$res=$dbroot->update($strsql);
					if (!$res)exit(-1);
				}
			}
		}
	}
	$res=unlink($strpath ."isgw.isdn.tmp");
}


function isdncfg_initoDB($db,$strpath){
global $DEBUG;
//echo "exist" . $strpath . "isdn.conf:" . file_exists($strpath . "isdn.conf") ."\n";
if (!file_exists($strpath . "isdn.conf"))exit(-1);
$result=make_parseable_inifile($strpath . "isdn.conf",$strpath ."isdn.conf.tmp");
$res=$db->delete("delete from isdn");
$cfg = parse_ini_file($strpath ."isdn.conf.tmp",true);
static $lifport=0;
foreach	($cfg as $section=>$values){
		unset ($master);
		unset($type);
		unset($clock);
		unset($ntteSW);
		unset($termination);
		unset ($ptp);
		unset ($portswitch);				
		
		switch ($section){
			
			case "lif0":
				$lifnr=0;
				$loop=0;
				break;				
			case "lif1":
				$lifnr=1;
				$loop=0;
				break;	
			case "pcm":
				if($DEBUG)echo "Nothing Todo for section: " . $section . "\n";	
				$loop=1;
				break;	
			default:
				if($DEBUG)echo "Unkown sectioname: " . $section . "\n";
				$loop=1;
				break;	
		}
		
		if($loop)continue;
		
		
		$type=$cfg[$section][type];
		if (($type!="bf4S0" && $type!="bf1E1" && $type!="bf2E1")){
			if($DEBUG)echo "Unkown module: " . $type . "\n";
			continue;
		}
		$ports=getports($type);
		$master=$cfg[$section][master];
		//echo "master " . $master . "\n";
		$clock=$cfg[$section][clock];
		//echo $clock . "\n";
		if ($master==0)$clock="0";
		$ntteSW=$cfg[$section][ntteSW];
		$ntteSW=split(",",$ntteSW);
		$ntteSW=getdefaultValue("NTTESW",$ntteSW,$ports);
		
		
		
		$clock=getdefaultValue("CLOCK",$clock,$ports);	
				
		if ($type=="bf4S0")
		{
			$termination=$cfg[$section][termination];
			$ptp=$cfg[$section][ptp];	
			$portswitch=$cfg[$section][portswitch];	
			$ntteHW=$cfg[$section][ntteHW];
				
			$termination=split(",",$termination);
			$ptp=split(",",$ptp);				
			$ntteHW=split(",",$ntteHW);				
			
			$termination=getdefaultValue("TERMINATION",$termination,$ports);
			$ptp=getdefaultValue("PTP",$ptp,$ports);
			$portswitch=getdefaultValue("PORTSWITCH",$portswitch,$ports);
			$ntteHW=getdefaultValue("NTTEHW",$ntteHW,$ports);
			//echo "1portswitch=" .$portswitch ."\n";
			//echo "type=" .$type . "ports=" . $ports ."\n";
		}else if($type=="bf1E1"){
			$termination=array("1");
			$ptp=array("1");
			$ntteHW=$ntteSW;
						
		}else if($type=="bf2E1"){
			$termination=array("1","1");
			$ptp=array("1","1");
			$ntteHW=$ntteSW;
		}
		
		
				
		
		for ($i = 0; $i < $ports; $i++)
		{
			$port=$i+1;
			$lifport++;
			/*
			$strsql="INSERT INTO isdn VALUES('" . $type . "'," . $lifnr ."," .  $lifport .",'NULL'";
			$strsql.= "," . $ptp[$i] . ",'" . $ntteSW[$i] . "','" . $ntteHW[$i] . "',''," . $termination[$i] . "," . $clock[$i];
			$strsql.= ",'standard','[de]',3,15," . $master .")";
			*/
			$strsql="INSERT INTO isdn ('type','lif','port','gr','ptp','ntteHW','ntteSW',";
			$strsql.="'config','lt','clock','chansel','tones','odt','odt_empty_dad','master')";
			$strsql.="VALUES('" . $type . "'," . $lifnr ."," .  $lifport .",'NULL'";
			$strsql.= "," . $ptp[$i] . ",'" . $ntteSW[$i] . "','" . $ntteHW[$i] . "',''," . $termination[$i] . "," . $clock[$i];
			$strsql.= ",'standard','[de]',3,15," . $master .")";
			
			if($DEBUG)echo "isdncfg->DB: " . $lifport . ":" . $strsql . "\n";
			$res=$db->insert_($strsql);
			
			if (!$res && !$DEBUG ) exit(-1);
			
				
		}
		
		if ($type=="bf4S0")
		{
					$strsql="Delete from key_val where key='portswitch'";
					$res=$db->delete($strsql);
					$strsql="Insert into key_val ('key','value') Values ('portswitch','" .$portswitch . "')";
					if($DEBUG)echo "isdncfg->DB: key_val Portswitch:" . $strsql . "\n";
					$res=$db->insert_($strsql);
					if (!$res && !$DEBUG) exit(-1);
					
		}
}//end first for loop

$res=unlink($strpath ."isdn.conf.tmp");

}
function getports($stype){
	$stype=trim(strtolower($stype));
						switch ($stype)
						{
							case bf4s0:
								return 4;
								break;
							case bf1e1:
								return 1;
								break;
							case bf2e1:
								return 2;
								break;
							default:
								return -1;
								break;
						}
}
function getdefaultValue($sname,$val,$iports){
	
	//unset($tmp);
	
	if($sname=="PORTSWITCH"){
		
		$arr=array('0','1');
		
		if (!in_array($val,$arr,true))exit(-1);
		return $val;
	}
	
	if ($sname=="CLOCK"){
		$arr=array('0','1','2','3','4','5');
		if (!in_array($val,$arr,true))exit(-1);
		if ($val==5){
					for ($i = 1; $i <= $iports; $i++)
					{
						$tmp[$i-1]="5";
					}
					
		}else{
				
					for ($i = 1; $i <= $iports ; $i++)
					{
						
						
						if ($val==$i){
							
							$tmp[$i-1]="1";
						}else{
							
							$tmp[$i-1]="0";
						}
					}
		}
		return $tmp;
	}	
	
	if ($sname=="PTP" || $sname=="TERMINATION"){
		if (count($val)!=$iports || !is_numeric($val[0])){
			
			/*for ($i = 1; $i <= $iports ; $i++){
				$tmp[$i-1]="1";
						
			}*/
			exit(-1);
			return $tmp;
				
		}
	}
	
	if ($sname=="NTTESW" || $sname=="NTTEHW"){
		if (count($val)!=$iports || empty($val[0])){
			
			/*for ($i = 1; $i <= $iports ; $i++){					
					$tmp[$i-1]="te";
			}*/
			exit(-1);
			return $tmp;			
		}			
	}
	
	return $val;
	
		
}


?>
