<?php


/**
 * Klasse State
 * Hier werden Daten angezeigt über die Konfigurationen von SIP und ISDN
 */

class State {

	/*
	 * Die Funktion ports wird benutzt um alle Ports die bei SIP konfiguriert
	 * worden sind anzuzeigen.
	 */
	function ports() {
		//Ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		$qu = $ba->select("select * from isdn");
		//Alle Einträge von der Abfrage werden durchgelaufen
		while ($entry = $ba->fetch_array($qu)) {
			//Für jede Port wird ein checkbox erzeugt
				$select .= "<input type=checkbox name='ports[]' value='" . $entry['port'] . "'>" . $entry['port'] . "&nbsp;&nbsp;";

		}
		//Alle checkboxs werden zurückgegeben*/
		return $select;
	}
	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {
		

		require_once "./includes/isgwtelnet.php";
		include('./includes/header.php');
		$isgw = new isgwtelnet();	
		$result=$isgw->isgw_login();
		if ($result==false) {
			$ret.="<font size='3' color='red'>ISGW must be started</font>"; 
			return $ret;
		}
		$isdnresult=$isgw->isgw_isdnstate();
		$sipresult=$isgw->isgw_sipstate();
		
		if (isset($_POST['port'])){
			$ret.= "<br/><font color='red'>".$isgw->port_restart($_POST['port'])."</font>";
		}

		//Die Informationen von dem Status von MISDN werden in eine Tabelle formatiert und in der
		//return-Variable der Funktion gespeichert
		
		$rows = "";
		$rows = explode("\n", $isdnresult);
		
		$ret .= "<br><br>";
		$ret .= "<table class='contenttoc' id='table1' width='95%'>";
		$ret .= "<th colspan=6>ISDN Status</th>";
		$ret .= "<tr><td><b>Port</b></td><td><b>Type</b></td><td><b>Prot.</b></td>";
		$ret .= "<td><b>L2Link</b></td><td><b>L1Link</b></td><td></td></tr>";
		
		foreach ($rows as $value){	
			$pos=strpos($value,"Port");
			if($pos !== false){
				$ret .= "<tr>";
				$tmp = split("Port ", $value);
				$port = split(" Type", $tmp[1]);
				$ret .= "<td>" . $port[0] . "</td>";
				$type = split(" Prot.", $port[1]);
				$ret .= "<td>" . $type[0] . "</td>";
				$prot = split(" L2Link", $type[1]);
				$ret .= "<td>" . $prot[0] . "</td>";
				$l2link = split(" L1Link:", $prot[1]);
				$l2link[0] = str_replace(" ", "", $l2link[0]);
				if ($l2link[0] == "UP") {
					$ret .= "<td><img src='./includes/images/punkt_gruen.gif'></td>";
				} else {
					$ret .= "<td><img src='./includes/images/punkt_rot.gif'></td>";
				}
				$l1link = split(" Blocked:", $l2link[1]);
				$l1link[0] = str_replace(" ", "", $l1link[0]);
				if ($l1link[0] == "UP") {
					$ret .= "<td><img src='./includes/images/punkt_gruen.gif'></td>";
				} else {
					$ret .= "<td><img src='./includes/images/punkt_rot.gif'></td>";
				}
				$ret .= "<td><form method='POST' class='extensions_form'>
							<input type='hidden' name='port' value='".$port[0]."'>
							<input type='submit' value='Restart'></form></td></tr>";
			}//endif
		}//endforeach

		$ret .= "</table><br/><br/>";				
		
		
		
		
		//Sip Resgistration
		$ret .= "<br/></br>";
		$ret .= "<table class='contenttoc' id='table' width='95%'>";
		$ret .= "<th colspan=4>Registration Status:</th>";
		$ret .= "<tr><td><b>Index</b></td><td><b>Registrar</b></td><td><b>User</b></td>";
		$ret .= "<td><b>Status</b></td></tr>";
		
		//echo $sipresult;	
		$rows = explode("\n", $sipresult);
		$i=0;
		for ($j=0;$j < count($rows)-3;$j++){
	//	foreach ($rows as $value){
			if ($i>0){
				if ($i==1 || $i==2 ||$i==3){
					$sp = split("=>", $rows[$j]);
					$v = str_replace(" ", "", $sp[1]);
					$ret.="<td>".$v."</td>";
				}
				if ($i == 4) {
					$sp = split("=>", $rows[$j]);
					$state = str_replace(" ", "", $sp[1]);
					if ($state == "REGISTERED") {
						$ret .= "<td><img src='./includes/images/punkt_gruen.gif'></td>";
					} else {
						$ret .= "<td><img src='./includes/images/punkt_rot.gif'></td>";
					}
				} 
				
			}else{
				$ret.="<tr>";
			}
			$i++;
			if ($i==9) {
				$ret .= "</tr>";
				$i=0;
			}
		}
		


		$ret .= "</table>";

		return $ret;
	}

}
?>
